#include "darwin_arm_kinematics.h"
#include "darwin_robot_exceptions.h"

#include <iostream>

std::string kin_file="../src/xml/right_arm.xml";

int main(int argc, char *argv[])
{
  std::vector<double> joints_in(4),joints_out(4),pos,rot_out,rot_in(3,0.0);
  int num_total=0,num_sol=0;
  double i,j,k,l;

  try{
    CDarwinArmKinematics kin;
    kin.load_chain(kin_file);

    joints_in[0]=atof(argv[1]);
    joints_in[1]=atof(argv[2]);
    joints_in[2]=atof(argv[3]);
    joints_in[3]=atof(argv[4]);
    kin.get_forward_kinematics(joints_in,pos,rot_out);
    std::cout << pos[0] << "," << pos[1] << "," << pos[2] << std::endl;
    return 0;
    pos.push_back(0.0743671);
    pos.push_back(0.0502218);
    pos.push_back(0.0791303);
    rot_in[0]=0;
    rot_in[1]=0;
    rot_in[2]=0;
    kin.get_inverse_kinematics(pos,rot_in,joints_out);
    std::cout << joints_out[0] << "," << joints_out[1] << "," << joints_out[2] << "," << joints_out[3] << std::endl;
    return 0;
    for(i=-1.5707;i<1.5707;i+=0.2)
    {
      for(j=-1.5707;j<1.5707;j+=0.2)
      {
        for(k=-1.5707;k<1.5707;k+=0.2)
        {
          for(l=-1.5707;l<1.5707;l+=0.2)
          {
            num_total++;
            joints_in[0]=i;
            joints_in[1]=j;
            joints_in[2]=k;
            joints_in[3]=l;
            try{
              std::cout << i << "," << j << "," << k << "," << l << std::endl;
              kin.get_forward_kinematics(joints_in,pos,rot_out);
              kin.get_inverse_kinematics(pos,rot_in,joints_out);
              std::cout << joints_out[0] << "," << joints_out[1] << "," << joints_out[2] << "," << joints_out[3] << std::endl;
              num_sol++;
            }catch(CException &e){
              std::cout << e.what() << std::endl;
            }
          }
        }
      }
    }
    std::cout << "Found " << num_sol << " solutions of " << num_total << " attempts" << std::endl; 

  }catch(CException &e){
    std::cout << e.what() << std::endl;
  }
}
